Unit BK01R3_p;
interface
uses
SysUtils, Math, { Delphi }
LStruct, Lfunc;

function BK01R3(A :Real; B :Real; X :Real): Real; 
implementation

function BK01R3(A :Real; B :Real; X :Real): Real;
var
M,ITMAX :Integer;
EPS,AM,BM,AZ,QAB,QAP,QAM,BZ,EM,TEM,D,AP,BP,APP,BPP,AOLD :Real;
label
_11,_1;
begin
ITMAX := 100;
EPS := 3.E-7;
AM := 1.0;
BM := 1.0;
AZ := 1.0;
QAB := A+B;
QAP := A+1.0;
QAM := A-1.0;
BZ := 1.0-QAB*X/QAP;
for M:=1 to ITMAX do
 begin
  EM := M;
  TEM := EM+EM;
  D := EM*(B-M)*X/((QAM+TEM)*(A+TEM));
  AP := AZ+D*AM;
  BP := BZ+D*BM;
  D := -(A+EM)*(QAB+EM)*X/((A+TEM)*(QAP+TEM));
  APP := AP+D*AZ;
  BPP := BP+D*BZ;
  AOLD := AZ;
  AM := AP/BPP;
  BM := BP/BPP;
  AZ := APP/BPP;
  BZ := 1.0;
  if ( Abs(AZ-AOLD) < EPS*Abs(AZ) )
   then goto _1;
_11:
 end;
{       US ' r  t big, r I t smll' }
_1:
Result := AZ;
end;

end.
