Unit BK04R4_p;
interface
uses
SysUtils, Math, { Delphi }
LStruct, Lfunc;

function BK04R4(XX :Real): Real; 
implementation

function BK04R4(XX :Real): Real;
var
J :Integer;
X,TMP,SER :Extended;
const
COF :Array [0..5] of Extended = ( 76.18009173e0,-86.50532033e0,24.01409822e0,
-1.231739516e0,120858003e-2,-0.536382e-5 );
STP :Extended = 2.50662827465e0;
HALF :Extended = 0.5e0;
ONE :Extended = 1.0e0;
FPF :Extended = 5.5e0;
label
_11;
begin
X := XX-ONE;
TMP := X+FPF;
TMP := (X+HALF)*Ln(TMP)-TMP;
SER := ONE;
for J:=1 to 6 do
 begin
  X := X+ONE;
  SER := SER+COF[J-1]/X;
_11:
 end;
{  Result -    BK04R4  FORTRAN }
Result := TMP+Ln(STP*SER);
end;

end.
