Unit BK02R_p;
interface
uses
SysUtils, Math, { Delphi }
LStruct, Lfunc, BK01R1_p, BK01R2_p;

procedure BK02R(var DATA1 :Array of Real; var N1 :Integer;
                var DATA2 :Array of Real; var N2 :Integer;
                var PROB :Real);

implementation

procedure BK02R(var DATA1 :Array of Real; var N1 :Integer;
                var DATA2 :Array of Real; var N2 :Integer;
                var PROB :Real);
var
AVE1,AVE2,VAR1,VAR2,DF,VAR_,T :Real;
begin
BK01R1(DATA1,N1,AVE1,VAR1);
BK01R1(DATA2,N2,AVE2,VAR2);
T := (AVE1-AVE2)/Sqrt(VAR1/N1+VAR2/N2);
DF := IntPower(VAR1/N1+VAR2/N2,2)/(IntPower(VAR1/N1,2)/(N1-1)+
IntPower(VAR2/N2,2)/(N2-1));
PROB := BK01R2(0.5*DF,0.5,DF/(DF+IntPower(T,2)));
end;

end.
